// function GameConnection::createVehicle(%this, %spawnPoint)
// {
//   if (isObject(%this.vehicle))
//   {
//     error("Attempting to create an angus ghost!");
//   }

//   %oldQuotaObject = getCurrentQuotaObject();

//   if (isObject(%oldQuotaObject))
//   {
//     clearCurrentQuotaObject();
//   }

//   %this.vehicle = new WheeledVehicle()
//   {
//     datablock = BoltVehicle;
//   };

//   if (isObject(%oldQuotaObject))
//   {
//     setCurrentQuotaObject(%oldQuotaObject);
//   }

//   if (!isObject(%this.vehicle))
//   {
//     error("ERROR: Failed to create vehicle");
//     return;
//   }

//   MissionCleanup.add(%this.vehicle);

//   %this.vehicle.client = %this;
//   %this.vehicle.spawnTime = getSimTime();

//   %this.vehicle.setTransform(%spawnPoint);
//   %this.vehicle.setShapeName(%this.getPlayerName());

//   commandToClient(%this, 'ShowEnergyBar', 0);
//   commandToClient(%this, 'PlayGui_CreateToolHud', 0);

//   %this.setControlObject(%this.vehicle);

//   %obj = new Projectile()
//   {
//     datablock = SpawnProjectile;

//     initialPosition = %this.vehicle.getHackPosition();
//     initialVelocity = "0 0 0";
//   };

//   MissionCleanup.add(%obj);

//   %obj.setScale(%this.vehicle.getScale());
//   %obj.explode();
// }

package RacePackage
{
  function WheeledVehicle::onDriverLeave(%this, %obj)
  {
    Parent::onDriverLeave(%this, %obj);

    if (%this.deleteOnEmpty)
    {
      %this.delete();
    }
  }

  function Player::activateStuff(%this)
  {
    if (!isObject(%this.getObjectMount()))
    {
      Parent::activateStuff(%this);
    }
  }

  function GameConnection::spawnPlayer(%this)
  {
    Parent::spawnPlayer(%this);

    if (%this.miniGame != $DefaultMiniGame || !isObject(%this.player))
    {
      return;
    }

    //%spawnPoint = %this.getSpawnPoint();
    %spawnPoint = "79.6812 -107.823 0.596215 0.000203986 0.000200214 -1 1.5518";
    %oldQuotaObject = getCurrentQuotaObject();

    if (isObject(%oldQuotaObject))
    {
      clearCurrentQuotaObject();
    }

    %max = -1;

    %choice[%max++] = CitiVehicle;
    %choice[%max++] = MicroCarVehicle;
    %choice[%max++] = MicroCar2Vehicle;
    %choice[%max++] = MicroCar3Vehicle;
    %choice[%max++] = EscargotVehicle;

    %vehicle = %choice[getRandom(%max)];

    %vehicle = new WheeledVehicle()
    {
      datablock = %vehicle;
      deleteOnEmpty = 1;
    };

    if (isObject(%oldQuotaObject))
    {
      setCurrentQuotaObject(%oldQuotaObject);
    }

    if (!isObject(%vehicle))
    {
      error("ERROR: Failed to create vehicle");
      return;
    }

    MissionCleanup.add(%vehicle);

    %vehicle.setTransform(%spawnPoint);
    %vehicle.setShapeName(%this.getPlayerName());

    %vehicle.player = %this.player;
    %vehicle.mountObject(%this.player, 0);

    %this.player.setShapeNameDistance(0);
    %this.player.setControlObject(%vehicle);
    %this.player.canDismount = 0;

    // if (!isObject($DefaultMiniGame) || %this.miniGame != $DefaultMiniGame)
    // {
    //   return Parent::spawnPlayer(%this);
    // }

    // if (isObject(%this.vehicle) && %this.vehicle.getDamagePercent() < 1)
    // {
    //   %this.vehicle.delete();
    // }

    // %spawnPoint = %this.getSpawnPoint();
    // %this.createVehicle(%spawnPoint);

    // if (isObject(%this.camera))
    // {
    //   %this.camera.unmountImage(0);
    // }

    // messageClient(%this, 'MsgYourSpawn');

    // if (!%this.hasSpawnedOnce)
    // {
    //   %this.hasSpawnedOnce = 1;
    //   echo(%this.getPlayerName() @ " spawned.");

    //   messageAllExcept(%client, -1, '', '\c1%1 spawned.', %this.getPlayerName());
    //   steamGetAchievement("ACH_HOST_SERVER", "steamGetAchievement");
    // }
  }

  function GameConnection::instantRespawn(%this, %clientAgain)
  {
    if (isObject(%this.vehicle))
    {
      %this.vehicle.delete();
    }

    Parent::instantRespawn(%this, %clientAgain);
  }

  function GameConnection::onClientLeaveGame(%this)
  {
    // if (isObject(%this.vehicle))
    // {
    //   %this.vehicle.delete();
    // }

    Parent::onClientLeaveGame(%this);
  }

  function WheeledVehicle::onDisabled(%this, %obj, %state)
  {
    // if (isObject(%obj.client))
    // {
    //   %obj.client.onDeath(0, 0, $DamageType::Vehicle, "body");
    // }

    Parent::onDisabled(%this, %obj, %state);
  }

  function serverCmdDropCameraAtPlayer(%client)
  {
    // if (!isObject($DefaultMiniGame) || %client.miniGame != $DefaultMiniGame)
    // {
      return Parent::serverCmdDropCameraAtPlayer(%client);
    // }

    // if (%client.isAdmin && isObject(%client.vehicle) && isObject(%client.camera))
    // {
    //   %client.camera.setTransform(%client.vehicle.getEyeTransform());
    //   %client.camera.setVelocity("0 0 0");
    //   %client.camera.mountImage(CameraImage, 0);

    //   %client.camera.setFlyMode();
    //   %client.camera.setMode("Observer");

    //   %client.setControlObject(%client.camera);
    // }
  }

  function serverCmdDropPlayerAtCamera(%client)
  {
    // if (!isObject($DefaultMiniGame) || %client.miniGame != $DefaultMiniGame)
    // {
      return Parent::serverCmdDropPlayerAtCamera(%client);
    // }

    // if (%client.isAdmin && isObject(%client.camera))
    // {
    //   if (isObject(%client.vehicle))
    //   {
    //     %client.vehicle.setTransform(%client.camera.getTransform());
    //     %client.vehicle.setVelocity("0 0 0");

    //     %client.setControlObject(%client.vehicle);
    //   }
    //   else
    //   {
    //     %client.spawnPlayer();
    //   }
    // }
  }
};

activatePackage("RacePackage");